utility APositionObjectsOnXYPlane "APositionObjectsOnXYPlane"
(
	local pluginDefinitionFile = @"C:\Users\digginc\Autodesk\3ds Max 2016\Max Creation Graph\Tools\APositionObjectsOnXYPlane.maxtool"
	local _pluginInstance -- the plugin instance created from the plugin definition
	local argsType = dotNetClass "System.Object[]" -- used when creating args array
	local dotnet_ValueToDotNetObject = dotnet.ValueToDotNetObject

	-- value wrapper local declarations

	fn initialize = 
	(
		local c = dotNetClass "Viper3dsMaxBridge.UtilityPluginInstance"
		_pluginInstance = c.CreateInstance pluginDefinitionFile

		-- value wrapper local initializations

	)

	spinner spacing "spacing" range:[0, 9999, 30] type:#float
	spinner row_size "row size" range:[1, 100, 1] type:#integer

	fn execute = 
	(
		if (_pluginInstance == undefined) then 
		( 
			initialize()
			if (_pluginInstance == undefined) then ( return undefined )
		)
		try 
		(

			local args = dotnet_ValueToDotNetObject #(spacing.value, row_size.value) argsType
			_pluginInstance.Execute (currentTime as integer) args

		)
		catch 
		(
			local msg = "evaluating procedural tool: " + (getCurrentException())
			displayTempPrompt msg 5000 -- 5 sec display of message
		)
		ok
	)

	button doit "Execute" 
	on doit pressed do ( execute () )
)